#ifndef PRINTTOOLS_H
#define PRINTTOOLS_H

#ifdef __cplusplus
extern "C" {
#endif


#include <stdio.h>
#include <stdlib.h>

#define ANSI_COLOR_RED     "\x1b[31m"
#define ANSI_COLOR_GREEN   "\x1b[32m"
#define ANSI_COLOR_YELLOW  "\x1b[33m"
#define ANSI_COLOR_BLUE    "\x1b[34m"
#define ANSI_COLOR_MAGENTA "\x1b[35m"
#define ANSI_COLOR_CYAN    "\x1b[36m"
#define ANSI_COLOR_RESET   "\x1b[0m"

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

//matrix layout
#ifndef ROW_MAJOR
#define ROW_MAJOR 1
#endif

#ifndef COLUMN_MAJOR
#define COLUMN_MAJOR -1
#endif

void check_matrix_dimensions(int length,int rows);

void print_info(const char* info);
void print_warning(const char* why, const char* where,const char* what);
void print_error(const char* why, const char* where,const char* what);

/* Auxiliary routines prototypes */
void print_matrix(const char *mname,const double* matrix, int length, int rows,int layout);

#ifdef __cplusplus
}
#endif

#endif /* PRINTTOOLS_H */
